//////////////////////////////////////////////////////////////////
//																//
// totalwar.cpp : Defines the entry point for the application.  //
//                                                              //
//	TOTALWAR version DirectX Visual C++ 6.00                    //
//	13/03/2001 17h47                                            //
//                                                              //
//////////////////////////////////////////////////////////////////

#include "stdafx.h"
#define INITGUID
#include "resource.h"
#include "windef.h"
#include "ddraw.h"
#include <mmsystem.h>
#include <dsound.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <dinput.h>


// Definition

#define SafeRelease(x) if (x) { x->Release(); x=NULL;}
#define KEYDOWN(buf,key) (buf[key] & 0x80)

// Variables globales

BOOL	BInit				=FALSE;
BOOL	Permut				=TRUE;
int		nPosition			=NULL;


static char szClass[]=	"TotalwarClass";


LPDIRECTDRAW7			lpDD		=NULL;	//objet DirectDraw
LPDIRECTDRAWSURFACE7	FondEcran	=NULL;	//surface primaire
LPDIRECTDRAWSURFACE7	Image		=NULL;	//bitmap
LPDIRECTDRAWSURFACE7	BackBuffer	=NULL;	//BackBuffer
LPDIRECTDRAWCLIPPER		lpClip		=NULL;	//clipper
LPDIRECTDRAWSURFACE7	Sprite		=NULL;	//Image des sprites
DWORD					KeyColor	=NULL;	//Couleur de transparence
LPDIRECTINPUT7			lpDInput	=NULL;	//Objet direct input
LPDIRECTINPUTDEVICE7	Keyboard	=NULL;	//Objet clavier
char Clavier[256];							//buffer clavier


// Declarations des fonctions

void DrawDC(void);		//Dessine la partie client de la fenetre
void Cleanup(void);		//Liberation des ressources
LPDIRECTDRAWSURFACE7 BitmapSurface(LPCTSTR file_name);
void EffaceEcran(LPDIRECTDRAWSURFACE7 surface);
DWORD InitKeyColor(LPDIRECTDRAWSURFACE7 surface);




LRESULT CALLBACK WindowProc(HWND hWnd, unsigned uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
			case IDM_EXIT:			//Menu Quitter

				DestroyWindow(hWnd);
				break;
			}
			break;

		case WM_PAINT:				//repeindre la fenetre
			PAINTSTRUCT ps;
			BeginPaint(hWnd,&ps);
			DrawDC();
			EndPaint(hWnd,&ps);
			break;
		case WM_DESTROY:			//quitter le programme
			Cleanup();
			PostQuitMessage(0);
			break;
		
		default:
			return DefWindowProc(hWnd,uMsg,wParam,lParam);
	}
	return 0L;
}

//////////////////////////////////////////////
//                                          //
//		        INITIALISATION              //
//                                          //
//////////////////////////////////////////////

static BOOL Init(HINSTANCE hInstance,int nCmdShow)
{
	WNDCLASS		wc;
	HRESULT			hRet;
	DDSURFACEDESC2	ddsd;

	//definit et inscrit la class de fenetre

	wc.style=			CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc=		(WNDPROC) WindowProc;
	wc.cbClsExtra=		0;
	wc.cbWndExtra=		sizeof(DWORD);
	wc.hInstance=		hInstance;
	wc.hIcon=			NULL;
	wc.hCursor=			LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=	(HBRUSH) GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName=	NULL; //MAKEINTRESOURCE(IDR_MENU);
	wc.lpszClassName=	szClass;

	//Teste si la fenetre en initialisation est correcte
	
	if (!RegisterClass(&wc))
	{
		MessageBox(NULL,"Erreur registration fentre","Totalwar",MB_OK);
		return FALSE;
	}

	//Obtient les dimensions de l'ecran

	int ScreenWidth=GetSystemMetrics(SM_CXSCREEN);
	int ScreenHeight=GetSystemMetrics(SM_CYSCREEN);

	//cree une fenetre et genere l'affichage
	HWND hWnd;

	hWnd=CreateWindow(szClass,"Totalwar",WS_POPUP,
		0,
		0,
		ScreenWidth,
		ScreenHeight,
		NULL,
		NULL,
		hInstance,
		NULL);

	if (!hWnd)
	{
		MessageBox(NULL,"Erreur cration fentre","Totalwar",MB_OK);		
		return FALSE;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	// Creation de l'Objet Directdraw

	hRet = DirectDrawCreateEx(NULL,(LPVOID*)&lpDD,IID_IDirectDraw7 , NULL);
	if (hRet != DD_OK)
	{
		MessageBox(NULL,"Erreur Cration objet DDraw","Totalwar",MB_OK);
		return FALSE;
	}

     // Fetch DirectDraw4 interface

    hRet = lpDD->QueryInterface(IID_IDirectDraw7, (LPVOID *) & lpDD);
    if (hRet != DD_OK)
	{
		MessageBox(NULL,"Erreur QueryInterface","Totalwar",MB_OK);
		return FALSE;
	}
	
	
	// Fixe le niveau de cooperation (Fullscreen)

    hRet = lpDD->SetCooperativeLevel(hWnd, DDSCL_FULLSCREEN|DDSCL_EXCLUSIVE|DDSCL_ALLOWREBOOT);
    if (hRet != DD_OK)
	{
		MessageBox(NULL,"Erreur cration coopration","Totalwar",MB_OK);
		return FALSE;
	}

	// Fixe la resolution ecran (640*480*16)

	hRet = lpDD->SetDisplayMode(640,480,16,0,0);
	if (hRet != DD_OK)
	{
		MessageBox(NULL,"Erreur de rsolution","Totalwar",MB_OK);
		return FALSE;
	}
	
	
	
	// Cree un clipper

	hRet = lpDD->CreateClipper(NULL,&lpClip,NULL);
	if (hRet != DD_OK)
	{
		MessageBox(NULL,"Erreur clipper","Totalwar",MB_OK);
		return FALSE;
	}
    
	lpClip->SetHWnd(0,hWnd);

	// Creation de la surface primaire + backbuffer

	ZeroMemory(&ddsd,sizeof(ddsd));
    ddsd.dwSize = sizeof( ddsd );
    ddsd.dwFlags = DDSD_CAPS|DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_FLIP|DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1;
    hRet = lpDD->CreateSurface( &ddsd, &FondEcran, NULL );
	if (hRet!=DD_OK)
	{
		MessageBox(NULL,"Erreur cration surface primaire","Totalwar",MB_OK);
		return FALSE;
	}

	// Obtenir l'interface du BackBuffer

	DDSCAPS2 ddscaps;
	ZeroMemory(&ddscaps, sizeof(ddscaps));
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	ddscaps.dwCaps2 = 0;
	ddscaps.dwCaps3 = 0;
	ddscaps.dwCaps4 = 0;
	hRet = FondEcran->GetAttachedSurface(&ddscaps,&BackBuffer);
	if (hRet != DD_OK)
	{
		MessageBox(NULL,"Erreur cration BackBuffer","Totalwar",MB_OK);
		return FALSE;
	}
	
	
	FondEcran->SetClipper(lpClip);

	BInit=TRUE;
	
	Image=BitmapSurface("fond04.bmp");
	Sprite=BitmapSurface("sprite00.bmp");
	EffaceEcran(BackBuffer);
	EffaceEcran(FondEcran);
	
	// Initialistion de la cle de couleur (0)
	//  pour les images sources

	KeyColor=InitKeyColor(FondEcran);
	DDCOLORKEY Cle;
	Cle.dwColorSpaceHighValue=KeyColor;
	Cle.dwColorSpaceLowValue=KeyColor;
	FondEcran->SetColorKey(DDCKEY_SRCBLT, &Cle);
	Image->SetColorKey(DDCKEY_SRCBLT, &Cle);

	// Initialisation de DirectInput

	if (DirectInputCreateEx(hInstance,DIRECTINPUT_VERSION,IID_IDirectInput7,(LPVOID*)&lpDInput,NULL)!=DI_OK)
	{
		MessageBox(NULL,"Erreur cration Objet DirectInput","Totalwar",MB_OK);
		return FALSE;
	}
	
	// Creation du clavier

	if ((lpDInput->CreateDeviceEx(GUID_SysKeyboard, IID_IDirectInputDevice7,
        (void**)&Keyboard, NULL))!=DI_OK)
	{
		MessageBox(NULL,"Erreur cration Objet Keyboard","Totalwar",MB_OK);
		return FALSE;
	}
	
	// Creation du format du clavier

	if ((Keyboard->SetDataFormat(&c_dfDIKeyboard))!=DI_OK) 
	{
		MessageBox(NULL,"Erreur cration Objet Keyboard","Totalwar",MB_OK);
		return FALSE;
	}

	// Fixer le niveau de cooperation

	if ((Keyboard->SetCooperativeLevel(hWnd, 
                   DISCL_FOREGROUND | DISCL_NONEXCLUSIVE))!=DI_OK)
	{
 		MessageBox(NULL,"Erreur Keyboard cooperation","Totalwar",MB_OK);
		return FALSE;
	}

	// Acquerir le clavier

	Keyboard->Acquire();





	return TRUE;
}

//////////////////////////////////////////////
//                                          //
//		          WINMAIN                   //
//                                          //
//////////////////////////////////////////////


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.

	MSG msg;
	LONGLONG cur_time;       // temps courant
	BOOL notDone=TRUE;       // flag for thread completion
	DWORD  time_count=16;    // ms per frame, default if no performance counter
	LONGLONG perf_cnt;       // performance timer frequency
	BOOL perf_flag=FALSE;    // flag determining which timer to use
	LONGLONG next_time=0;    // temps pour la prochaine image
	LONGLONG last_time=0;	 // temps de la derniere image
	double time_elapsed;	 // temps depuis la derniere image
	double time_scale;		 // facteur d'echelle pour le temps

	if (!Init(hInstance,nCmdShow))
	{
		Cleanup();
		MessageBox(NULL,"Erreur initialisation de l'instance","Totalwar",MB_OK);
		return FALSE;
	}

	if (QueryPerformanceFrequency((LARGE_INTEGER *) &perf_cnt))
	{ 
		// oui met le temps par image ainsi que le type de compteur 

		perf_flag=TRUE;
		time_count=(DWORD)(perf_cnt/90);
		QueryPerformanceCounter((LARGE_INTEGER *) &next_time); 
		time_scale=1.0/perf_cnt;

	} else { 

		// Pas de compteur de performance lire et utiliser timeGetTime 

		next_time=timeGetTime(); 
		time_scale=0.001;
	} 
	last_time=next_time;


	while (notDone)
	{
		if (PeekMessage(&msg,NULL,NULL,NULL,PM_REMOVE))
		{
			if (msg.message==WM_QUIT) 
				notDone=FALSE;

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}else{
			// utiliser la methode appropriee pour obtenir le emps 
			// et calculer le temps passe entre chaque image

			if (perf_flag) 
				QueryPerformanceCounter((LARGE_INTEGER *) &cur_time); 
			else 
				cur_time=timeGetTime(); 


			if (cur_time>next_time)
			{ 

				time_elapsed=(cur_time-last_time)*time_scale;
				last_time=cur_time;
				DrawDC();
                // Obtain input from the keyboard
                if (Keyboard->GetDeviceState(sizeof(Clavier),(LPVOID)&Clavier)
                    == DIERR_INPUTLOST)
                {
                    // Reacquire the keyboard and try again
                    if (Keyboard->Acquire() == DI_OK)
                        Keyboard->GetDeviceState(sizeof(Clavier),(LPVOID)&Clavier);
                }
                if (KEYDOWN(Clavier, DIK_LEFT))
                {
			
                }

                if (KEYDOWN(Clavier, DIK_RIGHT))
                {
		
                }

                if (KEYDOWN(Clavier, DIK_UP))
                {
			
                }

                if (KEYDOWN(Clavier, DIK_DOWN))
                {
			
                }

                if (KEYDOWN(Clavier, DIK_ESCAPE))
                {
					//DestroyWindow(hWnd);
                }
				
				next_time = cur_time + time_count;
			}
		}
	}

	return (msg.wParam);
	
}

//////////////////////////////////////////////
//                                          //
// Fonction de dessin sur surface/fenetre   //
//                                          //
//////////////////////////////////////////////

void DrawDC(void)
{

}

//////////////////////////////////////////////
//                                          //
// Fonction de liberation des ressources    //
//                                          //
//////////////////////////////////////////////

void Cleanup()
{
	if (Keyboard)
	{
		Keyboard->Unacquire();
		Keyboard->Release();
		Keyboard=NULL;
	}
	SafeRelease(lpDInput);
	SafeRelease(Image);
	SafeRelease(Sprite);
	SafeRelease(BackBuffer);
	SafeRelease(FondEcran);
	SafeRelease(lpClip);
	SafeRelease(lpDD);

}

//////////////////////////////////////////////
//                                          //
// Chargement d'un Bitmap et creation       //
//  d'une surface DDRAW sur cette surface   //
//                                          //
//////////////////////////////////////////////

LPDIRECTDRAWSURFACE7 BitmapSurface(LPCTSTR file_name)
{
	HDC hdc;
	HBITMAP bit;
	LPDIRECTDRAWSURFACE7 surf;

	// Chargement de la Bitmap

	bit=(HBITMAP) LoadImage(NULL,file_name,IMAGE_BITMAP,0,0,LR_DEFAULTSIZE|LR_LOADFROMFILE);
	if (!bit)
	{
		MessageBox(NULL,"Erreur chargement Bitmap","Totalwar",MB_OK);
		return NULL;
	}

	// Obtient les dimensions du Bitmap

	BITMAP bitmap;
    GetObject( bit, sizeof(BITMAP), &bitmap );
	int surf_width=bitmap.bmWidth;
	int surf_height=bitmap.bmHeight;

	// create surface

	HRESULT ddrval;
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd,sizeof(ddsd));
	ddsd.dwSize = sizeof(DDSURFACEDESC2);
	ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT ;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN|DDSCAPS_SYSTEMMEMORY; 
	ddsd.dwWidth = surf_width;
	ddsd.dwHeight = surf_height; 

	// Creation de la surface

	ddrval=lpDD->CreateSurface(&ddsd,&surf,NULL);

	if (ddrval!=DD_OK)
	{
		DeleteObject(bit);
		return NULL;

	} else {

		// Obtenir le DC pour la surface

		surf->GetDC(&hdc);

		// Generer une surface compatible

		HDC bit_dc=CreateCompatibleDC(hdc);

		// blit the interface to the surface

		SelectObject(bit_dc,bit);
		BitBlt(hdc,0,0,surf_width,surf_height,bit_dc,0,0,SRCCOPY);

		// Libere le DC

		surf->ReleaseDC(hdc);
		DeleteDC(bit_dc);

	}

	DeleteObject(bit);
	return surf;
}


void EffaceEcran(LPDIRECTDRAWSURFACE7 surface)
{

   	if (surface!=NULL)
		return;

    DDBLTFX ddbltfx;
	HRESULT ddrval;
	DDPIXELFORMAT ddpf;

	ddpf.dwSize = sizeof(ddpf);
	surface->GetPixelFormat(&ddpf);
 
    ddbltfx.dwSize = sizeof(ddbltfx); 
    ddbltfx.dwFillColor =(DWORD) 0; //ddpf.dwBBitMask; // Pure blue
 
    ddrval = surface->Blt( 
        NULL,        // Surface entiere
        NULL,        // Pas de surface source
        NULL,        // Pas de rectangle source
        DDBLT_COLORFILL, &ddbltfx); 
	
}


DWORD InitKeyColor(LPDIRECTDRAWSURFACE7 surface)
{
	DWORD Color;
	DDPIXELFORMAT ddpf;
	ddpf.dwSize=sizeof(ddpf);
	surface->GetPixelFormat(&ddpf);

	// Convertion RVB dans le format de pixel
	Color=ddpf.dwGBitMask;
	/*Color=(((DWORD)(ddpf.dwRBitMask*0))&ddpf.dwRBitMask)+
		  (((DWORD)(ddpf.dwGBitMask*0))&ddpf.dwGBitMask)+
		  (((DWORD)(ddpf.dwBBitMask*0))&ddpf.dwBBitMask);
	*/
	return Color;

}


